<template>
  <div :class="{ hidden: hidden }" class="pagination-container">
    <el-pagination
      :background="background"
      :current-page.sync="currentPage"
      :page-size.sync="pageSize"
      :layout="layout"
      :page-sizes="pageSizes"
      :total="total"
      v-bind="$attrs"
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
    />
  </div>
</template>

<script>
import { scrollTo } from '@/utils/scroll-to'

export default {
  name: 'Pagination',
  props: {
    total: {
      required: true,
      type: Number
    },
    page: {
      type: Number,
      default: 1
    },
    limit: {
      type: Number,
      default: 20
    },
    pageSizes: {
      type: Array,
      default() {
        return [10, 20, 30, 50]
      }
    },
    layout: {
      type: String,
      default: 'total, sizes, prev, pager, next, jumper'
    },
    background: {
      type: Boolean,
      default: true
    },
    autoScroll: {
      type: Boolean,
      default: false
    },
    hidden: {
      type: Boolean,
      default: false
    },
    skipCount: {
      type: Number,
      default: 0
    },
    maxResultCount: {
      type: Number,
      default: 20
    }
  },
  computed: {
    currentPage: {
      get() {
        return this.skipCount / this.maxResultCount + 1
      },
      set(val) {
        // this.$emit("update:page", val);
        this.$emit('update:skipCount', (val - 1) * this.maxResultCount)
      }
    },
    pageSize: {
      get() {
        return this.maxResultCount
      },
      set(val) {
        // this.$emit("update:limit", val);
        this.$emit('update:maxResultCount', val)
      }
    }
  },
  methods: {
    handleSizeChange(val) {
      this.$emit('pagination', {
        page: this.currentPage,
        limit: val,
        skipCount: (this.currentPage - 1) * val,
        maxResultCount: val
      })
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    },
    handleCurrentChange(val) {
      this.$emit('pagination', {
        page: val,
        limit: this.pageSize,
        skipCount: (this.val - 1) * this.pageSize,
        maxResultCount: this.pageSize
      })
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    }
  }
}
</script>

<style scoped>
.pagination-container.hidden {
  display: none;
}
</style>
